<template>
  <dialog-card :title="$t('dialogs.login.title')" :actions="actions">
    <!-- On enter pressed, try submitting manually -->
    <v-form
      lazy-validation
      @keydown.native.enter="tryClose"
    >
      <!-- Username field -->
      <v-text-field
        v-model="username" name="username"
        :label="$t('dialogs.login.username')" prepend-icon="mdi-account"
        :rules="[v => !!v || 'Username is required']"
        required
      />
      <!-- Password field -->
      <v-text-field
        v-model="password" name="password"
        :label="$t('dialogs.login.password')" prepend-icon="mdi-lock"
        required
        :error-messages="passwordMessage ? [passwordMessage] : []"
        :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
        :type="showPassword ? 'text' : 'password'"
        @click:append="showPassword = !showPassword"
      />
    </v-form>
  </dialog-card>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator';
import type { Client } from '@/client';
import { ClientStatus } from '@/client';

@Component
export default class LoginDialog extends Vue {
  loading = false;

  showPassword = false;

  username = '';

  password = '';

  passwordMessage = '';

  get actions() {
    // vuetify-dialog actions
    return {
      cancel: {
        text: this.$t('dialogs.login.cancel'),
        color: 'warning',
        handle: this.close,
      },
      login: {
        text: this.$t('dialogs.login.login'),
        color: 'success',
        handle: this.auth,
      },
    };
  }

  @Prop()
  client!: Client;

  /**
   * Returns true if login successful
   */
  async auth(): Promise<boolean> {
    const res = await this.client.login(this.username, this.password);

    if (res.isOk()) {
      this.client.user = res.data;
      return true;
    } if (res.status === ClientStatus.Unauth) {
      this.passwordMessage = 'Username and password do not match';
    } else if (res.status === ClientStatus.NoResponse) {
      this.passwordMessage = 'Could not reach server';
    } else {
      this.passwordMessage = 'Unknown error';
    }
    return false;
  }

  /**
   * Cancel login
   */
  close() {
    this.$emit('submit', false);
  }

  /**
   * Try auth, and login if successful
   */
  async tryClose() {
    if (await this.auth()) {
      this.$emit('submit', true);
    }
  }
}
</script>
